<?
 require_once($_path["include"]."module.php");

 class system_statistics_pluginConfigs extends Module
 {
  function init(&$data)
  {
   global $_path;

   parent::init($data);

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title=$this->data->l->t("System statistics plugin configuration");

   $this->data->addField("ssh_host", "hostname", "all", false, 1, 255, (isset($_SERVER["HTTP_HOST"])?$_SERVER["HTTP_HOST"]:""), "Host name");
   $this->data->addField("ssh_port", "nr", "all", false, 0, 65535, 22, "Port number");
   $this->data->addField("ssh_user", "title", "all", "reload", 0, 255, "", "User name");

   $this->data->group("SSH", "ssh_host", "ssh_port", "ssh_user", "ssh_pass");


   $this->data->addField("load", "boolean", "all", "", false, false, false, "System load");
   $this->data->addField("sensors", "multilist", "all", "", 0, 65536, "", "Sensors");
   $this->data->addField("networkdevs", "multilist", "all", "", 0, 65536, "", "Network devices");
   $this->data->addField("mounteddevices", "multilist", "all", "", 0, 65536, "", "Mounted devices");
   $this->data->addField("smartdisks", "multilist", "all", "", 0, 65536, "", "SMART (hard) disks");

   $this->data->group("Gather", "type", "sensors", "networkdevs", "mounteddevices", "smartdisks", "load");
  }

  function postInit()
  {
   if($this->data->action!="add"&&$this->data->action!="edit")
    return true;

   return $this->customizeFields();
  }
  function addPostGet(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   if($this->data->vmax==0&&($this->data->action!="add"||$this->data->extra=="copy")) //only change fields if object has data or if add new 
    return true;

   global $_path;
   require_once($this->data->plugin->path["root"]."ss.php");

   $success=true;

   if($this->data->vmax)
    $max=$this->data->vmax;
   else
    $max=1;

   for($c=0;$c<$max;$c++)
    $this->data->setValue("plugin", "system_statistics", $c);

   if(
    ($this->data->action=="add"||$this->data->action=="edit")&&
    ($this->data->getValue("ssh_host")&&$this->data->getValue("ssh_user")&&$this->data->getValue("ssh_port"))
   )
   {
    $ss=new SystemStatistics(Array(
     "ssh_host" => $this->data->getValue("ssh_host"), 
     "ssh_user" => $this->data->getValue("ssh_user"), 
     "ssh_port" => $this->data->getValue("ssh_port")
    ));

    if(!$ss->cli->exec("ls"))
    {
     $this->data->e->add($ss->cli->e);
     $success=false;
    }
   }
   else
    $ss=new SystemStatistics("");

   $options=Array();
   foreach($ss->availableSensors() as $sensor)
    $options[$sensor]=$sensor;

   $this->data->listOptions("sensors", $options);


   $options=Array();
   foreach($ss->availableNetworkDevices() as $dev)
    $options[$dev]=$dev;

   $this->data->listOptions("networkdevs", $options);


   $options=$ss->getMountedDevices();
   $this->data->listOptions("mounteddevices", $options);


   $options=$ss->getSmartDisks();
   $this->data->listOptions("smartdisks", $options);
  
   return $success;
  }

 }
?>
