<?
 require_once($_path["include"]."fs.php");
 require_once($_path["include"]."cli.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."error.php");
 require_once($_path["include"]."plugin.php");

 class SystemStatistics
 {
  function SystemStatistics($configKey)
  {
   $this->cli=new CLI();
   $this->e=&$this->cli->e;

   if(is_array($configKey))
   {
    $this->config=$configKey;
    $this->configKey=false;;
   }
   else
   {
    $this->config=false;
    $this->configKey=$configKey;
   }

   if($this->configKey)
   {
    $d=Data::cache("system_statistics_pluginConfigs", "view", "all");
    $d->setValue("key", $this->configKey);
    $d->get();

    if($d->next())
     $this->config=$d->v;

    unset($d);
   }

   if($this->config["ssh_host"]&&$this->config["ssh_user"]&&$this->config["ssh_port"])
    $this->cli->ssh($this->config["ssh_host"], $this->config["ssh_user"], $this->config["ssh_port"]);

   $this->keys=false;

   $this->execs=Array(
    "sensors" => "sensors",
    "nvidia-sensors" => "nvidia-smi",
    "cat" => "cat",
    "grep" => "grep",
    "smartctl" => "smartctl",
    "sudo" => "sudo",
    "df" => "df",
   );

   //find executables
   foreach($this->execs as $key => $exec)
   {
    if($this->cli->exec("which ".$exec)&&$this->cli->return==0)
     $this->execs[$key]=$this->cli->output[0];
    else
     $this->execs[$key]=false;
   }

   $this->e->clear();
  }

  function gather()
  {
   if($this->config)
   {
    if($this->config["load"])
     if(!$this->load())
      return false;

    if($this->config["sensors"])
     if(!$this->sensors())
      return false;

    if($this->config["networkdevs"])
     if(!$this->networking())
      return false;

    if($this->config["mounteddevices"])
     if(!$this->diskspace())
      return false;

    if($this->config["smartdisks"])
     if(!$this->disktemperature())
      return false;
   }

   return true;
  }

  function key($keypath, $unit=false, $info=false)
  {
   if(!$this->keys)
   {
    $this->keys=Data::cache("system_statistics_keys", "tree", "down");
    $this->keys->clearValues();
    $this->keys->setValue("keynr", 0);
    $this->keys->get();
   }

   $this->keys->reset();
   while($this->keys->next())
   {
    if($this->keys->v["keypath"]==$keypath)
    {
     $nr=$this->keys->v["nr"];

     if(($unit!==false&&$unit!=$this->keys->v["unit"])||($info!==false&&$info!=$this->keys->v["info"]))
     {
      $this->keys->action="edit";
      $this->keys->extra="item";
      $this->keys->clearValues();

      $this->keys->setValue("unit", $unit);
      $this->keys->setValue("info", $info);
      $this->keys->setValue("nr", $nr);
      $this->keys->submit();

      $this->keys->action="tree";
      $this->keys->extra="down";
      $this->keys->clearValues();
      $this->keys->setValue("keynr", 0);
      $this->keys->get();
     }

     return $nr;
    }
   }
 
   $path="";
   $lastkey=0;
   $this->keys->reset();

   $keypath=explode("->", $keypath);
   $l=sizeof($keypath);

   for($c=0;$c<$l;$c++)
   {
    if(!$path)
     $path=$keypath[$c];
    else 
     $path.="->".$keypath[$c];

    $found=false;

    while($this->keys->next())
    {
     if($this->keys->v["keypath"]==$path)
     {
      $lastkey=$this->keys->v["nr"];
      $found=true;
      break;
     }
    }

    if(!$found)
    {
     $this->keys->action="add";
     $this->keys->extra="item";
     $this->keys->clearValues();

     $this->keys->setDefaultValue("userrights");
     $this->keys->setValue("key", $keypath[$c]);
     $this->keys->setValue("keynr", $lastkey);

     if($c==($l-1)) //only safe units and info for last key
     {
      $this->keys->setValue("unit", $unit);
      $this->keys->setValue("info", $info);
     }
     else
     {
      $this->keys->setValue("unit", "");
      $this->keys->setValue("info", "");
     }

     $this->keys->submit();
     $lastkey=$this->keys->getValue("nr");
     
     $this->keys->action="tree";
     $this->keys->extra="down";
     $this->keys->clearValues();
     $this->keys->setValue("keynr", 0);
     $this->keys->get();
    }
   }

   return $lastkey;
  }


/*********************
LOAD 
*********************/

  function load()
  {
   if($this->e->any("fatal"))
    return false;

   $found=false;
   $d=Data::cache("system_statistics_load", "add", "item");

   if($this->execs["cat"]&&$this->cli->exec($this->execs["cat"]." /proc/loadavg"))
   {
    foreach($this->cli->output as $line)
    {
     if(preg_match("/^([0-9\.]+) ([0-9\.]+) ([0-9\.]+) ([0-9]+)\/([0-9]+)/", $line, $tmp))
     {
      $d->setValue("avgload1", $tmp[1]); 
      $d->setValue("avgload5", $tmp[2]); 
      $d->setValue("avgload15", $tmp[3]); 
      $d->setValue("activeprocs", $tmp[4]); 
      $d->setValue("totalprocs", $tmp[5]); 
   
      $d->setValue("keynr", $this->key($this->config["ssh_host"]."->System load", "Procs", "Active processes")); 

      if(!$d->submit())
       $this->e->add($d->e);
     }
    }
   }

   if($this->e->any("fatal"))
    return false;

   return true;
  }


/*********************
SENSORS
*********************/

  function sensors()
  {
   if($this->e->any("fatal"))
    return false;

   $d=Data::cache("system_statistics_sensors", "add", "item");

   $info="";
   $sensor="";
   if($this->execs["sensors"]&&$this->cli->exec($this->execs["sensors"]))
   {
    foreach($this->cli->output as $line)
    {
     if(!$sensor&&$line)
      $sensor=$line;
     else if(!$info&&$line)
      $info=$line;
     else if(!$line) //next sensor
     {
      $sensor="";
      $info="";
     }
     else
     {
      if(preg_match("/^\s*([^\:]+)\:\s+([\+\-]?)([\d\.]+)\s*([^\s]+)/", $line, $tmp))
      {
       if(!in_array($sensor."->".$tmp[1], $this->config["sensors"]))
        continue;

       $d->setValue("keynr", $this->key($this->config["ssh_host"]."->Sensors->".$sensor."->".$tmp[1], $tmp[4], $info)); 

       if($tmp[2]=="-")
        $d->setValue("value", "-".$tmp[3]); 
       else
        $d->setValue("value", $tmp[3]); 

       if(!$d->submit())
        $this->e->add($d->e);
      }
     }
    }
   }

   if($this->e->any("fatal"))
    return false;

   //check nvidia sensor availability
   $tmp=$this->e->logging; //temporary disable logging
   $this->e->logging="none";
   if(!$this->execs["nvidia-sensors"]||!$this->cli->exec($this->execs["nvidia-sensors"]." -L")) //test nvidia sensors command
   {
    $this->e->clear();
    $this->e->add("NVidia sensors not available", "note");

    $this->e->logging=$tmp; //reset logging 
    return true;
   }
   $this->e->logging=$tmp; //nvidia sensors command ok, reset logging 

   if($this->execs["nvidia-sensors"]&&$this->cli->exec($this->execs["nvidia-sensors"]." -a -q"))
   {
    foreach($this->cli->output as $line)
    {
     if(preg_match("/Product Name\s+:\s(.+)$/", $line, $tmp))
      $sensor=$tmp[1];
     else if($sensor)
     {
      if(preg_match("/(Temperature)\s+:\s(\d+)\s(.+)$/", $line, $tmp)||
         preg_match("/(Fan Speed)\s+:\s(\d+)(.+)$/", $line, $tmp)||
         preg_match("/(GPU)\s+:\s(\d+)(.+)$/", $line, $tmp)||
         preg_match("/(Memory)\s+:\s(\d+)(.+)$/", $line, $tmp)
        )
      {
       if(!in_array($sensor."->".$tmp[1], $this->config["sensors"]))
        continue;

       $d->setValue("keynr", $this->key($this->config["ssh_host"]."->Sensors->".$sensor."->".$tmp[1], $tmp[3])); 

       $d->setValue("value", $tmp[2]); 

       if(!$d->submit())
        $this->e->add($d->e);
      }
     }
    }
   }

   if($this->e->any("fatal"))
    return false;

   return true;
  }

  function availableSensors()
  {
   if($this->e->any("fatal"))
    return Array();

   $sensor="";
   $sensors=Array();
   if($this->execs["sensors"]&&$this->cli->exec($this->execs["sensors"]))
   {
    foreach($this->cli->output as $line)
    {
     if(!$sensor&&$line)
      $sensor=$line;
     else if(!$line) //next sensor
      $sensor="";
     else if(preg_match("/^\s*([^\:]+)\:\s+([\+\-]?)([\d\.]+)\s*([^\s]+)/", $line, $tmp))
      $sensors[]=$sensor."->".$tmp[1];
    }
   }

   //check nvidia sensor availability
   $tmp=$this->e->logging; //temporary disable logging
   $this->e->logging="none";
   if(!$this->execs["nvidia-sensors"]||!$this->cli->exec($this->execs["nvidia-sensors"]." -L")) //test nvidia sensors command
   {
    $this->e->clear();
    $this->e->add("NVidia sensors not available", "note");

    $this->e->logging=$tmp; //reset logging 
    return $sensors;
   }
   $this->e->logging=$tmp; //nvidia sensors command ok, reset logging 

   $sensor="";
   if($this->execs["nvidia-sensors"]&&$this->cli->exec($this->execs["nvidia-sensors"]." -a -q"))
   {
    foreach($this->cli->output as $line)
    {
     if(preg_match("/Product Name\s+:\s(.+)$/", $line, $tmp))
      $sensor=$tmp[1];
     else if($sensor)
     {
      if(preg_match("/(Temperature)\s+:\s(\d+)\s(.+)$/", $line, $tmp)||
         preg_match("/(Fan Speed)\s+:\s(\d+)(.+)$/", $line, $tmp)||
         preg_match("/(GPU)\s+:\s(\d+)(.+)$/", $line, $tmp)||
         preg_match("/(Memory)\s+:\s(\d+)(.+)$/", $line, $tmp)
        )
       $sensors[]=$sensor."->".$tmp[1];
     }
    }
   }

   return $sensors;
  }


/*********************
NETWORKING
*********************/

  function networking()
  {
   if($this->e->any("fatal"))
    return false;

   $d=Data::cache("system_statistics_networking", "add", "item");

   if($this->execs["cat"]&&$this->cli->exec($this->execs["cat"]." /proc/net/dev"))
   {
    foreach($this->cli->output as $line)
    {
     if(preg_match("/^\s*([^\:]+)[^\d]+(\d+)[^\d]+\d+[^\d]+\d+[^\d]+\d+[^\d]+\d+[^\d]+\d+[^\d]+\d+[^\d]+\d+[^\d]+(\d+).*$/", $line, $tmp))
     {
      if(!in_array($tmp[1], $this->config["networkdevs"]))
       continue;

      $d->setValue("keynr", $this->key($this->config["ssh_host"]."->Networking->".$tmp[1], "bytes")); 

      $d->setValue("rx", $tmp[2]); 
      $d->setValue("tx", $tmp[3]); 

      if(!$d->submit())
       $this->e->add($d->e);
     }
    }
   }

   if($this->e->any("fatal"))
    return false;

   return true;
  }

  function availableNetworkDevices()
  {
   if($this->e->any("fatal"))
    return Array();

   $devs=Array();
   if($this->execs["cat"]&&$this->cli->exec($this->execs["cat"]." /proc/net/dev"))
   {
    foreach($this->cli->output as $line)
    {
     if(preg_match("/^\s*([^\:]+)[^\d]+\d+/", $line, $tmp))
      $devs[]=$tmp[1];
    }
   }

   return $devs;
  }


/*********************
DISK SPACE 
*********************/

  function diskspace()
  {
   if($this->e->any("fatal"))
    return false;

   $d=Data::cache("system_statistics_diskspace", "add", "item");

   $halfline=false;
   if($this->execs["df"]&&$this->cli->exec($this->execs["df"]." -B 1 -T"))
   {
    foreach($this->cli->output as $line)
    {
     if($halfline)
     {
      $line=$halfline.$line;
      $halfline=false;
     }
     else if(!preg_match("/\s/", $line))
     {
      $halfline=$line;
      continue;
     }

     if(preg_match("/^([^\s]+)\s+([^\s]+)\s+(\d+)\s+(\d+)\s+(\d+)\s+[^\s]+\s([^\s]+)$/", $line, $tmp))
     {
      if(!in_array($tmp[6], $this->config["mounteddevices"]))
       continue;

      $d->setValue("keynr", $this->key($this->config["ssh_host"]."->Disk space->".$tmp[6], "bytes", $tmp[1])); 

      $d->setValue("total", $tmp[3]); 
      $d->setValue("used", $tmp[4]); 
      $d->setValue("available", $tmp[5]); 
      
      if(!$d->submit())
       $this->e->add($d->e);
     }
    }
   }

   if($this->e->any("fatal"))
    return false;

   return true;
  }

  function getMountedDevices()
  {
   if($this->e->any("fatal"))
    return Array();

   $halfline=false;
   $devs=Array();

   if($this->execs["df"]&&$this->cli->exec($this->execs["df"]." -B 1 -T"))
   {
    foreach($this->cli->output as $line)
    {
     if($halfline)
     {
      $line=$halfline.$line;
      $halfline=false;
     }
     else if(!preg_match("/\s/", $line))
     {
      $halfline=$line;
      continue;
     }

     if(preg_match("/^([^\s]+)\s+([^\s]+)\s+(\d+)\s+(\d+)\s+(\d+)\s+[^\s]+\s([^\s]+)$/", $line, $tmp))
      $devs[$tmp[6]]=$tmp[6]." - ".$tmp[1];
    }
   }

   return $devs;
  }



/*********************
DISK TEMPERATURE
*********************/

  function disktemperature()
  {
   if($this->e->any("fatal"))
    return false;

   $d=Data::cache("system_statistics_disktemperature", "add", "item");

   foreach($this->config["smartdisks"] as $disk)
   {
    if($this->execs["sudo"]&&$this->execs["smartctl"]&&$this->execs["grep"]&&$this->cli->exec($this->execs["sudo"]." ".$this->execs["smartctl"]." -A -i ".$disk." | ".$this->execs["grep"]." -i \"^\(194\|Model\|Device model\)\"")&&$this->cli->return==0) //get temperature and model from physical disk 
    {
     $info=implode("\n", $this->cli->output);
     if(preg_match("/\s+-\s+(\d+)/", $info, $temperature))
     {
      $temperature=$temperature[1];

      if(preg_match("/Model Family:\s+ (.+)/i", $info, $family))
       $family=$family[1];
      else
       $family=false;

      if(preg_match("/Device Model:\s+ (.+)/i", $info, $model))
       $model=$model[1];
      else
       $model=false;

      if($model)
      {
       if($family)
        $model.=" - ".$family;
      }
      else if($family)
        $model=$family;

      $d->setValue("keynr", $this->key($this->config["ssh_host"]."->Disk temperature->".$disk, "C", $model)); 

      $d->setValue("temperature", $temperature); 
      
      if(!$d->submit())
       $this->e->add($d->e);
     }
    }
   }

   if($this->e->any("fatal"))
    return false;

   return true;
  }

  function getSmartDisks()
  {
   if($this->e->any("fatal"))
    return Array();

   $devs=Array();

   if($this->execs["cat"]&&$this->execs["grep"]&&$this->cli->exec($this->execs["cat"]." /proc/diskstats | ".$this->execs["grep"]." \"sd[a-z] \"")) //get all physical disks
   {
    foreach($this->cli->output as $line)
    {
     if(preg_match("/^\s+[^\s]+\s+[^\s]+\s+(sd[a-z])/", $line, $tmp))
     {
      if($this->execs["sudo"]&&$this->execs["smartctl"]&&$this->execs["grep"]&&$this->cli->exec($this->execs["sudo"]." ".$this->execs["smartctl"]." -A -i /dev/".$tmp[1]." | ".$this->execs["grep"]." \"^194\"")&&$this->cli->return==0) //get physical disks with temperature support
      {
       $devs[]="/dev/".$tmp[1];
      }
     }
    }
   }

   return $devs;
  }

 }
?>
