<?
 require_once($_path["include"]."dt.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."form.php");
 require_once($_path["include"]."template.php");
 require_once($_path["include"]."functions.php");

 class system_statistics extends BasePlugin
 {

  function main()
  {
   if($this->config)
    $this->output=$this->graph($this->config["key"]);
  } 

  function graph($configKey)
  {
   global $_path;

   $colors=Array(
    "4488DD", "44DD88", "8844DD", "88DD44", "DD8844", "DD4488", 
    "0066AA", "00AA66", "6600AA", "66AA00", "AA6600", "AA0066", 
    "88DDFF", "88FFDD", "DD88FF", "DDFF88", "FFDD88", "FF88DD", 
   );

   
   //get graphs plugin
   $graphplugin=new Plugin("graphs");

   if($graphplugin->e->any())
   {
    $this->e->add($graphplugin->e);
    return $this->e->show();
   }
   else if(!$graphplugin->isEnabled())
   {
    $this->e->add("Graphs plugin isn't enabled");
    return $this->e->show();
   }

   require_once($graphplugin->path["root"]."graph.php");
   unset($graphplugin);


   //get config
   $d=Data::cache("system_statistics_pluginConfigs", "view", "all");
   $d->setValue("plugin", $this->plugin->name);
   $d->setValue("key", $configKey);

   if(!$d->get()||!$d->next())
    return $d->e->show();

   $output="";


   //get from and to date time request vars
   if(!($from=request("from"))||!($from=DT::dateConvert($from, $d->format["form"]["datetimeformat"])))
    $from=mktime(0, 0, 0);
   
   if(!($to=request("to"))||!($to=DT::dateConvert($to, $d->format["form"]["datetimeformat"])))
    $to=86400+$from;

   if($from==$to)
    $to++;
   else if($from>$to)
   {
    $tmp=$from;
    $from=$to;
    $to=$tmp;
   }

   //aggregation
   if(($to-$from)>(86400*365)) //period more then 1 year
    $aggregation=86400*30.42; //aggregate per month
   else if(($to-$from)>(86400*30.42)) //period more then 1 month
    $aggregation=86400; //aggregate per day
   else if(($to-$from)>(86400*5)) //period more then 5 days
    $aggregation=86400/6; //aggregate per 4 hours
   else //less then 5 days
    $aggregation=false; //don't aggregate


   //get statistics types request vars
   if(!($load=request("load")))
    $load=false;

   if(!($sensors=request("sensors"))||!is_array($sensors))
    $sensors=Array();

   if(!($networkdevs=request("networkdevs"))||!is_array($networkdevs))
    $networkdevs=Array();

   if(!($mounteddevices=request("mounteddevices"))||!is_array($mounteddevices))
    $mounteddevices=Array();

   if(!($smartdisks=request("smartdisks"))||!is_array($smartdisks))
    $smartdisks=Array();


   //render form
   $f=new Form();
   $output.=$f->start();

   foreach($this->plugin->vars as $k => $v)
    $output.=$f->input("hidden", $k, $v)."\n";

   $output.=$f->input("hidden", "graph", $d->getValue("key"))."\n";
   $output.="<div class=\"field\"><div class=\"title\">Date</div><div class=\"input\">".$f->input("text", "from", date($d->format["form"]["datetimeformat"], $from))." Till<br/>".$f->input("text", "to", date($d->format["form"]["datetimeformat"], $to))."</div></div>\n";


   $output.="<div class=\"field\"><table class=\"overview\">";

   $output.="<tr>\n";

   if($d->v["load"])
    $output.="<th>".$d->title("load")."</th>\n";
   if($d->v["sensors"])
    $output.="<th>".$d->title("sensors")."</th>\n";
   if($d->v["networkdevs"])
    $output.="<th>".$d->title("networkdevs")."</th>\n";
   if($d->v["mounteddevices"])
    $output.="<th>".$d->title("mounteddevices")."</th>\n";
   if($d->v["smartdisks"])
    $output.="<th>".$d->title("smartdisks")."</th>\n";

   $output.="</tr><tr>\n";

   if($d->v["load"])
    $output.="<td>".$f->checkbox($load, "Load", "load", 1)."</td>\n";

   if($d->v["sensors"])
   {
    $output.="<td>";

    foreach($d->v["sensors"] as $option)
     $output.=$f->checkbox(in_array($option, $sensors), $option, "sensors[]", $option)."<br/>";

    $output.="</td>\n";
   }

   if($d->v["networkdevs"])
   {
    $output.="<td>";

    foreach($d->v["networkdevs"] as $option)
     $output.=$f->checkbox(in_array($option, $networkdevs), $option, "networkdevs[]", $option)."<br/>";

    $output.="</td>\n";
   }

   if($d->v["mounteddevices"])
   {
    $output.="<td>";

    foreach($d->v["mounteddevices"] as $option)
     $output.=$f->checkbox(in_array($option, $mounteddevices), $option, "mounteddevices[]", $option)."<br/>";

    $output.="</td>\n";
   }

   if($d->v["smartdisks"])
   {
    $output.="<td>";

    foreach($d->v["smartdisks"] as $option)
     $output.=$f->checkbox(in_array($option, $smartdisks), $option, "smartdisks[]", $option)."<br/>";

    $output.="</td>\n";
   }

   $output.="</tr>\n</table></div>\n";


   $output.="<div class=\"field\"><div class=\"title\"></div><div class=\"input\">".$f->input("submit", "s", "Show")."</div></div>\n";
   $output.=$f->end();


   //nothing selected, done 
   if(!$load&&!$sensors&&!$networkdevs&&!$mounteddevices&&!$smartdisks)
    return $output;;


   //get keys
   $dk=Data::cache("system_statistics_keys", "view", "all");
   $dk->setShowFields("nr", "key", "keypath", "unit", "info");
   $dk->get();

   //prepare graph rendering
   $baseField="timestamp";

   $keys=Array();
   $fields=Array();

   if($load)
   {
    $keys["load"]=Array();
    $fields["load"]=Array();

    $dk->reset();
    while($dk->next())
    {
     if(($d->v["ssh_host"]?$d->v["ssh_host"]:$_SERVER["HTTP_HOST"])."->System load"==$dk->v["keypath"])
     {
      $keys["load"][$dk->v["nr"]]=$dk->v;
      $keys["load"][$dk->v["nr"]]["name"]="System load";
      break;
     }
    }

//    $fields["load"][]="totalprocs";
    $fields["load"][]="avgload1";
    $fields["load"][]="avgload5";
   }

   if($sensors)
   {
    $keys["sensors"]=Array();
    $fields["sensors"]=Array();

    foreach($sensors as $sensor)
    {
     $dk->reset();
     while($dk->next())
     {
      if(($d->v["ssh_host"]?$d->v["ssh_host"]:$_SERVER["HTTP_HOST"])."->Sensors->".$sensor==$dk->v["keypath"])
      {
       $keys["sensors"][$dk->v["nr"]]=$dk->v;
       $keys["sensors"][$dk->v["nr"]]["name"]=$sensor;
       break;
      }
     }
    }

    $fields["sensors"][]="value";
   }

   if($networkdevs)
   {
    $keys["networking"]=Array();
    $fields["networking"]=Array();

    foreach($networkdevs as $dev)
    {
     $dk->reset();
     while($dk->next())
     {
      if(($d->v["ssh_host"]?$d->v["ssh_host"]:$_SERVER["HTTP_HOST"])."->Networking->".$dev==$dk->v["keypath"])
      {
       $keys["networking"][$dk->v["nr"]]=$dk->v;
       $keys["networking"][$dk->v["nr"]]["name"]=$dev;
       break;
      }
     }
    }

    $fields["networking"][]="transmittedpersecond";
    $fields["networking"][]="receivedpersecond";
   }

   if($mounteddevices)
   {
    $keys["diskspace"]=Array();
    $fields["diskspace"]=Array();

    foreach($mounteddevices as $dev)
    {
     $dk->reset();
     while($dk->next())
     {
      if(($d->v["ssh_host"]?$d->v["ssh_host"]:$_SERVER["HTTP_HOST"])."->Disk space->".$dev==$dk->v["keypath"])
      {
       $keys["diskspace"][$dk->v["nr"]]=$dk->v;
       $keys["diskspace"][$dk->v["nr"]]["name"]=$dev;
       break;
      }
     }
    }

    $fields["diskspace"][]="used";
    $fields["diskspace"][]="total";
   }

   if($smartdisks)
   {
    $keys["disktemperature"]=Array();
    $fields["disktemperature"]=Array();

    foreach($smartdisks as $dev)
    {
     $dk->reset();
     while($dk->next())
     {
      if(($d->v["ssh_host"]?$d->v["ssh_host"]:$_SERVER["HTTP_HOST"])."->Disk temperature->".$dev==$dk->v["keypath"])
      {
       $keys["disktemperature"][$dk->v["nr"]]=$dk->v;
       $keys["disktemperature"][$dk->v["nr"]]["name"]=$dev;
       break;
      }
     }
    }

    $fields["disktemperature"][]="temperature";
   }


   //configure graph
   $graph=new Graph();

   $graph->axis("x", "horizontal", $from, $to);
   $graph->dateFormat("x", $d->format["html"]["datetimeformat"]);
   $graph->interval("x", ($to-$from)/12);
   $graph->indicator("x");
   $graph->labels("x");
   $graph->color("x", "888888");

   $graph->grid("x");
   $graph->color("grid_x", "EEEEEE");

   $graph->text("x", "Time", 1);
   $graph->color("x_l1", false, false, "888888"); //axe title color


   $graph->axis("y1", "x", 0);
   $graph->display("y1", "humanreadable");

   $graph->margin("y1", .1);
   $graph->indicator("y1");
   $graph->labels("y1");
   $graph->color("y1", "888888");

   $graph->grid("y1");
   $graph->color("grid_y1", "CCCCCC");


   $graph->axis("y2", "x", 0);
   $graph->display("y2", "humanreadable");

   $graph->margin("y2", .1);
   $graph->indicator("y2");
   $graph->labels("y2");


   $graph->color("y2", "888888");


   //render graph
   $output.="<h2>".$d->v["key"]."</h2>";
   $output.=$graph->style();


   $legendY1=1;
   $legendY2=1;
   $averageY=false;
   foreach($keys as $module => $k) //run through all keys and accompanying modules
   {
    $dr=Data::cache($this->plugin->name."_".$module, "view", "all");

    foreach($k as $keynr => $key) 
    {
     //get all values for the key within the from/to period
     $dr->clearValues();
     $dr->setValue("keynr", $keynr, 0);
     $dr->setValue("keynr", $keynr, 1);
     $dr->setValue($baseField, date($d->format["form"]["datetimeformat"], $from), 0);
     $dr->setValue($baseField, date($d->format["form"]["datetimeformat"], $to), 1);
     $dr->setOperator($baseField, ">=", 0);
     $dr->setOperator($baseField, "<", 1);

     //setup aggregation
     if($aggregation)
     {
      $dr->setValue("aggregation_field", $baseField); //use timestamp as aggregation_field
      $dr->setValue("aggregation_type", "average"); //show average value per period
      $dr->setValue("aggregation_method", "before"); //timestamp will indicate the coming period (4 hours, day, months, etc)
      $dr->setValue("aggregation_interval", $aggregation); //determined above based on from/to period
     }

     $dr->setShowFields(array_merge(Array($baseField), $fields[$module]));
     $dr->sortOrder($baseField);
     $dr->get();

     if($dr->vmax) //results?
     {
      $axe=false; //needed for fields grouping
      foreach($fields[$module] as $field) //render each field 
      {
       if(!$color=array_shift($colors))
        $color="444444";

       //create values list for graph
       $tmp=Array();
       for($c=0;$c<$dr->vmax;$c++)
        $tmp[]=$dr->getValue($baseField, $c).",".$dr->sqlValue($field, $c); 

       //determine which axe this set of fields should be rendered to
       if($axe==false) 
       {
        //calculate average value for field
        $total=0;
        for($c=0;$c<$dr->vmax;$c++)
         $total+=$dr->sqlValue($field, $c); 

        $average=$total/$dr->vmax;

        if($averageY===false) //Y axe doesn't have an avery set yet
         $averageY=$average; //use first

        
        if($average>($averageY*1.5)||$average<($averageY*.5)) //field average more then 50% lower or higher then Y axe average
         $axe="y2"; //use y2 (right)
        else
         $axe="y1"; //use y1 (left)
       }

       //set up line
       $graph->line($keynr.$field, $axe, $tmp);
       $graph->width($keynr.$field, 1);
       $graph->color($keynr.$field, $color);


       //determine which legend block the legende text should be rendered to
       if($axe=="y2")
        $graph->rectangle("legend".$keynr.$field, "500,".$legendY2, "900,".$legendY2+=20);
       else 
        $graph->rectangle("legend".$keynr.$field, "50,".$legendY1, "450,".$legendY1+=20);

       //render legend text
       if($module=="sensors")
        $graph->text("legend".$keynr.$field, $key["name"]." (".$key["unit"].")");
       else if($module=="disktemperature")
        $graph->text("legend".$keynr.$field, $key["name"].": ".preg_replace("/^.+ - /", "", $key["info"])." (".$key["unit"].")");
       else if($module=="networking"||$module=="diskspace")
        $graph->text("legend".$keynr.$field, $key["name"].": ".$dr->t[$field]);
       else
        $graph->text("legend".$keynr.$field, $dr->t[$field]);

       $graph->textAlign("legend".$keynr.$field, "left");
       $graph->color("legend".$keynr.$field, "FFFFFFAA", false, $color."AA");
      }
     }
    }
   }
    
   if(!$graph->items["y1"]["rinterval"])
   {
    $graph->_determineAxe("y1");
    $graph->interval("y1", ceil($graph->items["y1"]["max"]-$graph->items["y1"]["min"])/10);
   }

   if(isset($graph->items["y2"])&&!$graph->items["y2"]["rinterval"])
   {
    $graph->_determineAxe("y2");
    $graph->interval("y2", ceil($graph->items["y2"]["max"]-$graph->items["y2"]["min"])/10);
   }

   $graph->dateFormat("x", "G:i");
   $output.=$graph->render(900, 450)."";
   
   return $output;
  }
 }

?>
